import { Stack } from '../utils/stack';
import { ContextInstruction } from './context';
import { Instruction } from './instruction';
export interface BytecodeGeneratorContext {
    code: Instruction[];
    jumpPoints: [ContextInstruction, ContextInstruction][];
}
export declare class Module {
    protected _target: string;
    protected _context: Stack<BytecodeGeneratorContext>;
    constructor(target: string);
    get target(): string;
    get context(): Stack<BytecodeGeneratorContext>;
    isGlobalScope(): boolean;
    pushContext(): void;
    popContext(): BytecodeGeneratorContext;
    getCurrentIp(): number;
    getCode(): Instruction[];
    pushCode(item: Instruction): void;
    getJumpPoint(): [ContextInstruction, ContextInstruction];
    pushJumppoint(start: ContextInstruction, end: ContextInstruction): void;
    popJumppoint(): [ContextInstruction, ContextInstruction];
}
